local debugGraph = require("lib/debugGraph")
local bind_methods
bind_methods = require("lib/moon").bind_methods
local TimerContext
TimerContext = require("timer").TimerContext
local Controls
Controls = require("input").Controls
local GameEngine
do
  local _class_0
  local _parent_0 = TimerContext
  local _base_0 = {
    add_state = function(self, name, state)
      self.states[name] = state
      if self.state == nil then
        self.state = state
      end
    end,
    load_state = function(self, name, arg)
      if self.state == nil then
        self.state:unload()
      end
      self.state = self.states[name]
      self.state:resize(self.width, self.height)
      return self.state:load(arg)
    end,
    start = function(self, lovelib)
      lovelib.draw = function()
        return self:draw()
      end
      lovelib.update = function(dt)
        for name, control in pairs(Controls) do
          control:update()
        end
        return self:_update(dt)
      end
      lovelib.resize = bind_methods(self).resize
      return lovelib.mouse.setVisible(false)
    end,
    draw = function(self)
      return self.state:draw()
    end,
    _update = function(self, dt)
      _class_0.__parent.__base._update(self, dt)
      return self.state:_update(dt)
    end,
    resize = function(self, w, h)
      self.width = w
      self.height = h
      print(w, h)
      for name, state in pairs(self.states) do
        print(name, state)
        state:resize(w, h)
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self)
      _class_0.__parent.__init(self)
      self.states = { }
      self.state = nil
      self.width = love.graphics.getWidth()
      self.height = love.graphics.getHeight()
    end,
    __base = _base_0,
    __name = "GameEngine",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  GameEngine = _class_0
end
return {
  GameEngine = GameEngine
}
