local GameEngine
GameEngine = require("gameengine").GameEngine
local GameState, QuitState
do
  local _obj_0 = require("gamestate")
  GameState, QuitState = _obj_0.GameState, _obj_0.QuitState
end
local PlayState
PlayState = require("playstate").PlayState
local Controls
Controls = require("input").Controls
local g = love.graphics
local MainMenuState
do
  local _class_0
  local _parent_0 = GameState
  local _base_0 = {
    update = function(self, dt)
      if Controls.Vertical:pressed(1) then
        if self.selected < #self.menu - 1 then
          self.selected = self.selected + 1
        end
      else
        if Controls.Vertical:pressed(-1) then
          if self.selected > 0 then
            self.selected = self.selected + -1
          end
        else
          if Controls.Primary:pressed() then
            return self.menu[self.selected + 1].func()
          end
        end
      end
    end,
    draw = function(self)
      g.setColor(0, 0, 32)
      g.rectangle("fill", 0, 0, self.engine.width, self.engine.height)
      g.setColor(255, 255, 255)
      g.push()
      g.translate(self.engine.width / 2 - 200, self.engine.height / 2 - self.fontsize)
      g.setFont(self.font)
      local i = 0
      local _list_0 = self.menu
      for _index_0 = 1, #_list_0 do
        local item = _list_0[_index_0]
        if self.selected == i then
          g.setColor(255, 255, 255)
        else
          g.setColor(170, 170, 255)
        end
        g.printf(item.label, 0, i * (self.fontsize + self.fontpadding), 400, "center")
        i = i + 1
      end
      g.pop()
      return g.setColor(255, 255, 255)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, engine, menu)
      _class_0.__parent.__init(self, engine)
      self.menu = menu
      self.selected = 0
      self.fontsize = 24
      self.fontpadding = 16
      self.font = love.graphics.newFont("assets/fonts/PressStart2P-Regular.ttf", self.fontsize)
    end,
    __base = _base_0,
    __name = "MainMenuState",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  MainMenuState = _class_0
end
love.load = function(args)
  for _, flag in ipairs(args) do
    if flag == "-f" or flag == "--foo" then
      local foo = true
    end
  end
  local game = GameEngine()
  local menu = {
    {
      label = "Play",
      func = function()
        return game:load_state("game")
      end
    },
    {
      label = "Quit",
      func = function()
        return game:load_state("quit")
      end
    }
  }
  game:add_state("mainmenu", MainMenuState(game, menu))
  if PlayState ~= nil then
    game:add_state("game", PlayState(game))
  end
  game:add_state("quit", QuitState(game))
  return game:start(love)
end
