local lume = require('lib/lume')
local Vector = require('lib/vector-light')
local Script = require('scripts/script')
local SnakeAI
do
  local _class_0
  local _parent_0 = Script
  local _base_0 = {
    onAdd = function(self, e)
      e.script_time = 0
      e.script_attack_timeout = 0
      return e.events:listen("kill", function()
        if (math.random() > 0.5) then
          local tmp = {
            tx = e.tx,
            ty = e.ty
          }
          return self.state:create_entity(tmp, lume.randomchoice({
            'ammo',
            'red_potion'
          }))
        end
      end)
    end,
    is_player = function(o)
      return o.player ~= nil
    end,
    update = function(self, e, dt)
      e.script_time = e.script_time + dt
      local speed = love.math.noise(e.script_time * 0.1 + e.id - 123)
      local results = self.state:search(e.tx, e.ty, 48, self.is_player)
      local player = nil
      if results then
        player = results[1]
      end
      if player then
        if e.script_time >= e.script_attack_timeout then
          e.script_attack_timeout = e.script_time + 0.5
          local dx, dy = Vector.sub(player.tx, player.ty, e.tx, e.ty)
          dx, dy = Vector.normalize(dx, dy)
          e.ax = dx * e.acc
          e.ay = dy * e.acc
          e.events:say("attack melee")
          e.events:say("anim change", "attack", function()
            e.anim_running = false
            return e.events:say("anim change", "idle")
          end)
        end
      else
        if speed > 0.5 then
          speed = speed
        else
          speed = 0
        end
        e.rot = e.rot + ((love.math.noise(e.script_time * 0.01 + e.id * 13.41) * 2 - 1) * 2)
        e.ax = math.sin(e.rot) * e.acc * speed
        e.ay = math.cos(e.rot) * e.acc * speed
      end
      if e.anim_running ~= true then
        if e.vx ~= 0 or e.vy ~= 0 then
          if e.anim_track ~= "walk" then
            return e.events:say("anim change", "walk")
          end
        else
          if e.anim_track ~= "idle" then
            return e.events:say("anim change", "idle")
          end
        end
      end
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, ...)
      return _class_0.__parent.__init(self, ...)
    end,
    __base = _base_0,
    __name = "SnakeAI",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  SnakeAI = _class_0
end
return SnakeAI
