local _Timer
do
  local _class_0
  local _base_0 = {
    update = function(self, dt, time)
      if time > self.timeout then
        self:callback()
        if self.count > 0 then
          self.count = self.count - 1
          if self.count <= 0 then
            return false
          end
        end
        self.timeout = time + self.interval
      end
      return true
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self, time, interval, callback, count, every)
      if callback == nil then
        callback = nil
      end
      if count == nil then
        count = -1
      end
      if every == nil then
        every = nil
      end
      self.interval = interval
      self.callback = callback
      self.every = every
      self.count = count
      self.timeout = time + interval
    end,
    __base = _base_0,
    __name = "_Timer"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  _Timer = _class_0
end
local TimerContext
do
  local _class_0
  local _base_0 = {
    reset = function(self)
      self.time = 0
      self.timers = { }
    end,
    Timer = function(self, interval, cb, count, every)
      if count == nil then
        count = -1
      end
      if every == nil then
        every = nil
      end
      local t = _Timer(self.time, interval, cb, count, every)
      table.insert(self.timers, t)
      return t
    end,
    _update = function(self, dt)
      self.time = self.time + dt
      local i = 1
      while i <= #self.timers do
        if self.timers[i]:update(dt, self.time) == false then
          table.remove(self.timers, i)
        else
          i = i + 1
        end
      end
    end
  }
  _base_0.__index = _base_0
  _class_0 = setmetatable({
    __init = function(self)
      return self:reset()
    end,
    __base = _base_0,
    __name = "TimerContext"
  }, {
    __index = _base_0,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  TimerContext = _class_0
end
return {
  TimerContext = TimerContext
}
